/*
    The code in this file uses open source libraries provided by thecoderscorner

    DO NOT EDIT THIS FILE, IT WILL BE GENERATED EVERY TIME YOU USE THE UI DESIGNER
    INSTEAD EITHER PUT CODE IN YOUR SKETCH OR CREATE ANOTHER SOURCE FILE.

    All the variables you may need access to are marked extern in this file for easy
    use elsewhere.
 */

#include <tcMenu.h>
#include "picoAdafruitDashboard_menu.h"
#include "ThemeCoolBlueModern.h"
#include <Fonts/RobotoMedium24.h>

// Global variable declarations
const  ConnectorLocalInfo applicationInfo = { TC_I18N_PROJECT_NAME, "0ad4bdde-34a4-4507-912e-b495b0eac2c1" };
TcMenuRemoteServer remoteServer(applicationInfo);

Adafruit_ILI9341 gfx(20, 18, 19);
AdafruitDrawable gfxDrawable(&gfx, 40);
GraphicsDeviceRenderer renderer(30, applicationInfo.name, &gfxDrawable);
NoInitialisationNeeded serialInitializer;
SerialTagValueTransport serialTransport(&Serial);
TagValueRemoteServerConnection serialConnection(serialTransport, serialInitializer);

// Global Menu Item declarations
const BooleanMenuInfo minfoSettingsCheckBox = { "CheckBox", 9, 0xffff, 1, NO_CALLBACK, NAMING_CHECKBOX };
BooleanMenuItem menuSettingsCheckBox(&minfoSettingsCheckBox, false, nullptr, INFO_LOCATION_PGM);
const BooleanMenuInfo minfoSettingsYesNo = { TC_I18N_MENU_8_NAME, 8, 0xffff, 1, NO_CALLBACK, NAMING_YES_NO };
BooleanMenuItem menuSettingsYesNo(&minfoSettingsYesNo, false, &menuSettingsCheckBox, INFO_LOCATION_PGM);
const AnyMenuInfo minfoSettingsRGB = { TC_I18N_MENU_7_NAME, 7, 0xffff, 0, NO_CALLBACK };
Rgb32MenuItem menuSettingsRGB(&minfoSettingsRGB, RgbColor32(0, 0, 0), false, &menuSettingsYesNo, INFO_LOCATION_PGM);
const AnyMenuInfo minfoSettingsAction = { "Action", 6, 0xffff, 0, onSettingsAction };
ActionMenuItem menuSettingsAction(&minfoSettingsAction, &menuSettingsRGB, INFO_LOCATION_PGM);
const SubMenuInfo minfoSettings = { TC_I18N_MENU_5_NAME, 5, 0xffff, 0, NO_CALLBACK };
BackMenuItem menuBackSettings(&minfoSettings, &menuSettingsAction, INFO_LOCATION_PGM);
SubMenuItem menuSettings(&minfoSettings, &menuBackSettings, nullptr, INFO_LOCATION_PGM);
const BooleanMenuInfo minfoPower = { "Power", 4, 0xffff, 1, NO_CALLBACK, NAMING_ON_OFF };
BooleanMenuItem menuPower(&minfoPower, false, &menuSettings, INFO_LOCATION_PGM);
const char enumStrEnum_0[] = TC_I18N_MENU_3_ENUM_0;
const char enumStrEnum_1[] = TC_I18N_MENU_3_ENUM_1;
const char enumStrEnum_2[] = TC_I18N_MENU_3_ENUM_2;
const char* const enumStrEnum[]  = { enumStrEnum_0, enumStrEnum_1, enumStrEnum_2 };
const EnumMenuInfo minfoEnum = { TC_I18N_MENU_3_NAME, 3, 0xffff, 2, NO_CALLBACK, enumStrEnum };
EnumMenuItem menuEnum(&minfoEnum, 0, &menuPower, INFO_LOCATION_PGM);
const FloatMenuInfo minfoFloat = { TC_I18N_MENU_2_NAME, 2, 0xffff, 3, NO_CALLBACK };
FloatMenuItem menuFloat(&minfoFloat, 33.123, &menuEnum, INFO_LOCATION_PGM);
const AnalogMenuInfo minfoAnalog = { TC_I18N_MENU_1_NAME, 1, 0xffff, 1000, NO_CALLBACK, 0, 10, TC_I18N_MENU_1_UNIT };
AnalogMenuItem menuAnalog(&minfoAnalog, 222, &menuFloat, INFO_LOCATION_PGM);

void setupMenu() {
    // First we set up eeprom and authentication (if needed).
    CombinedMessageProcessor::setFormTemplatesInFlash(tcMenuAllEmbeddedForms);
    setSizeBasedEEPROMStorageEnabled(false);
    // Code generated by plugins and new operators.
    gfx.begin();
    gfx.setRotation(1);
    renderer.setUpdatesPerSecond(5);
    switches.init(internalDigitalIo(), SWITCHES_POLL_EVERYTHING, true);
    menuMgr.initForEncoder(&renderer, &menuAnalog, 16, 17, 21);
    remoteServer.addConnection(&serialConnection);
    renderer.setTitleMode(BaseGraphicalRenderer::TITLE_FIRST_ROW);
    renderer.setUseSliderForAnalog(true);
    installCoolBlueModernTheme(renderer, MenuFontDef(&RobotoMedium24, 1), MenuFontDef(&RobotoMedium24, 1), false);
}

// Embedded form data

const uint8_t formData_MobilePico_d8[] {
0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xcd,0x94,0xdb,0x4b,0xc3,0x30,
0x18,0xc5,0xdf,0x05,0xff,0x87,0x10,0xf0,0x6d,0xb5,0x69,0x57,0x2f,0x83,0x56,0xd1,
0x59,0x2f,0xb0,0xb5,0x63,0xa6,0xea,0xdb,0x48,0x9b,0x28,0x85,0x34,0x9f,0xf4,0xe2,
0xe5,0xbf,0xf7,0x6b,0x1d,0xda,0x29,0xa2,0x0f,0x13,0x7d,0x4b,0x4e,0xc2,0xf9,0x7e,
0x39,0x81,0xe3,0x1f,0x3e,0x15,0x9a,0x3c,0xa8,0xb2,0xca,0xc1,0x04,0xd4,0xd9,0x66,
0x94,0x28,0x93,0x81,0xcc,0xcd,0x5d,0x40,0x13,0x7e,0x6a,0xed,0x53,0x52,0xd5,0xc2,
0x48,0xa1,0xc1,0xa8,0x80,0x1a,0xa0,0x87,0x07,0x9b,0x1b,0x7e,0x58,0xa4,0x4a,0x8e,
0xc1,0xd4,0x25,0x68,0x92,0x82,0x28,0x65,0xd2,0xe4,0x32,0xa0,0x4c,0x48,0x2f,0x95,
0x52,0x59,0x43,0x4f,0x78,0x96,0xb7,0xc3,0xf6,0xac,0x91,0xe3,0x2a,0x2b,0xf5,0x46,
0x3b,0x29,0x53,0x22,0x73,0x33,0x87,0x12,0x2d,0x9e,0xa1,0xa9,0x23,0x51,0xa0,0xe3,
0x14,0xd2,0x5c,0x2b,0x32,0xcb,0x33,0xa0,0xe8,0x4c,0x88,0x3f,0x55,0xa6,0x99,0x74,
0x37,0xaa,0x4e,0x58,0x91,0x48,0x06,0xba,0x0a,0xa8,0x4b,0xc9,0x2d,0x4e,0xbf,0x30,
0xb7,0x80,0xd8,0x8c,0x6d,0x51,0x52,0xaa,0xac,0xc1,0x77,0x3c,0xa0,0x67,0x5d,0x36,
0x0a,0x05,0x80,0xfa,0xa2,0x65,0xa2,0x4b,0x9b,0xa5,0x51,0xa8,0x55,0xa1,0x4c,0x4d,
0x84,0xce,0xef,0x4c,0xbb,0x0a,0xe8,0x24,0x3c,0xe5,0xb4,0xb5,0x86,0xf2,0x52,0xe1,
0xfe,0x4c,0x43,0x2a,0x74,0xab,0x74,0x2f,0xe4,0xcf,0xf7,0xe8,0x9a,0xcc,0x16,0x27,
0xf1,0x75,0xb4,0x18,0xc7,0x11,0x9f,0xc7,0x13,0x3c,0x6d,0xaa,0x1a,0x8a,0x93,0x52,
0x3c,0xb6,0xc1,0x18,0x1c,0x29,0x71,0x3d,0x05,0x89,0x97,0x2f,0xcf,0xe3,0xeb,0x45,
0x74,0x34,0x0d,0x17,0x57,0x47,0x93,0x24,0xfc,0x8c,0x8b,0x83,0x9b,0x96,0x0e,0xe3,
0xb8,0x87,0x2a,0xaf,0xbb,0x0f,0x60,0x03,0x36,0x70,0x06,0x2e,0xb5,0xd7,0x43,0xcc,
0xc3,0x1b,0xbe,0x66,0x5c,0xb7,0x8f,0xeb,0xac,0x17,0xf7,0x77,0x02,0x1e,0xf6,0x89,
0xdd,0x1f,0x13,0x8f,0xc3,0x88,0x87,0xf3,0x6f,0x99,0x8f,0x13,0xce,0xe3,0x75,0x23,
0x7b,0x7d,0xe4,0xe1,0x80,0xfd,0x31,0xee,0xd7,0xa0,0xbb,0xab,0xa0,0xce,0x3f,0xcf,
0x75,0xbf,0x8f,0xeb,0xfd,0x79,0xae,0xdf,0xe1,0x8e,0x56,0x71,0xdf,0xd3,0xf5,0xed,
0xf7,0x42,0x7c,0xed,0x4c,0xfb,0x63,0x69,0xfa,0xe3,0x25,0x70,0x65,0x2f,0xf7,0x6f,
0x44,0xd8,0xed,0x9d,0xe8,0xdb,0xfd,0x16,0x47,0xe1,0x05,0xa0,0xe7,0xfa,0xa6,0x0e,
0x06,0x00,0x00
};
const EmbedControlFlashedForm formData_MobilePico {
    "Mobile Pico",
    formData_MobilePico_d8,
    419
};

const EmbedControlFlashedForm* tcMenuAllEmbeddedForms[] { &formData_MobilePico, nullptr };
